#include <opencv2/highgui.hpp>
#include <opencv2/imgproc.hpp>
#include <opencv2/core.hpp>
#include <opencv2/imgcodecs.hpp>
#include <iostream>
#include <string>

int
main(int argc, char** argv)
{
	if (argc != 3) {
		std::cerr << "usage: " << argv[0] << " device photo" << std::endl;
		return -1;
	}

	std::string str = argv[1];
	std::string gstformat = "NV12";
	std::string gstfile = "v4l2src device=" + str + " ! video/x-raw,format=" + gstformat + ",width=3840,height=2160,framerate=30/1 ! videoconvert ! appsink";
	cv::VideoCapture capture(gstfile);
	std::string outputPath = argv[2];

	cv::Mat frame;
	for (int i = 0; i < 30; i++)
		capture >> frame;
	if (frame.empty()) {
		std::cerr << "Cannot read a valid frame" << std::endl;
		return -1;
	} else {
		cv::imwrite(outputPath, frame);
		return 0;
	}
}
